#ifndef PRINTSTATE_H_
#define PRINTSTATE_H_

#ifdef NDEBUG

#define printword(text, w)
#define printstate(text, s)

#else

#include <inttypes.h>
#include <stdio.h>

#include "ascon.h"
#include "word.h"

__forceinline void printword(const char* text, const word_t x) {
  printf("%s=%016" PRIx64 "\n", text, WORDTOU64(x));
}

__forceinline void printstate(const char* text, const state_t* s) {
  printf("%s:\n", text);
  printword("  x0", s->x0);
  printword("  x1", s->x1);
  printword("  x2", s->x2);
  printword("  x3", s->x3);
  printword("  x4", s->x4);
}

#endif

#endif /* PRINTSTATE_H_ */
